
## Simulation from fitted CPH model
simCoxPH <- function(sims, before, after, baseline=0) {
    crossRR <- sims^(after - before)
    res <- c(mean(crossRR), quantile(crossRR, probs=c(0.025, 0.975)))
    res
}

## Add lags to dataset
makeplags <- function(model,data,c,t,lags=1,notation="L") {

  require(simcf)
  
  if (length(c)==1) {
    c <- data[[c]]
  }
  if (length(t)==1) {
    t <- data[[t]]
  }
  
  outnames <- outdata <- NULL
  allv <- all.vars(model)

  for (j in 1:length(allv)) {
    for (i in 1:length(lags)) {      
      outnames <- c(outnames,
                    glue(allv[j], notation, lags[i])
                    )  
      outdata <- cbind(outdata,
                       lagpanel(data[[allv[j]]], c, t, lags[i])
                       )
    }
  }
  outdata <- as.data.frame(outdata)
  names(outdata) <- outnames
  outdata
}

